#ifndef sbr_H
#define sbr_H

#if defined __i386__ && defined __GNUC__
extern inline int sbr(unsigned int n)
{
   asm ("bsr %%eax, %%eax": "=a" (n) : "a" (n) );
   return n;
}
#else
extern int sbr(unsigned int n);
#endif

extern inline int sbr_longlong(unsigned long long n)
{
   int i = (n>>32);
   return i ? 32 + sbr(i) : sbr(n);
}

/* Returns true if n is a power of 2 */
/* Works for any iteger type */
#define is_power_of_two(n)    (!((n) & ((n)-1)))

#endif
