#include "bitboard.h"

/* Special bitboards, used for masking */
/* Board minus the a and h files, used for move generation */
const BITBOARD board_empty   = 0x0000000000000000ll;
const BITBOARD board_all     = 0xFFFFFFFFFFFFFFFFll;
const BITBOARD board_minus_a = 0xFEFEFEFEFEFEFEFEll;
const BITBOARD board_minus_h = 0x7F7F7F7F7F7F7F7Fll;
const BITBOARD board_centre  = 0x0000001818000000ll;
const BITBOARD board_xcentre = 0x00003C24243C0000ll;
const BITBOARD board_kwing   = 0xF0F0F0F0F0F0F0F0ll;
const BITBOARD board_qwing   = 0x0F0F0F0F0F0F0F0Fll;
const BITBOARD board_rank1   = 0x00000000000000FFll;
const BITBOARD board_rank2   = 0x000000000000FF00ll;
const BITBOARD board_rank3   = 0x0000000000FF0000ll;
const BITBOARD board_rank4   = 0x00000000FF000000ll;
const BITBOARD board_rank5   = 0x000000FF00000000ll;
const BITBOARD board_rank6   = 0x0000FF0000000000ll;
const BITBOARD board_rank7   = 0x00FF000000000000ll;
const BITBOARD board_rank8   = 0xFF00000000000000ll;

static void print_uint8(uint8 b)
{
   int c;
   
   for (c=0; c<8; c++) {
      printf ("%d", (b>>c)&1);
   }
}

void printf_bitboard(BITBOARD b)
{
   int c;

   for (c=7; c>=0; c--) {
      print_uint8(get_bitboard_row(b, c));
      printf("\n");
   }
}
